#!/usr/bin/perl

use strict;

#define some variables

my $size = 1000;
my $spares = 20;
my $seed = 1;
#y $degdist = "\"(2,0.412500);(3,0.362500);(8,0.040000);(9,0.080000);(19,0.040000);(20,0.040000);(375,0.025000);\"";
my $degdist = "\"(2,0.404450);(3,0.339390);(7,0.068364);(14,0.140910);(250,0.046886);\"";
#my @degs = (2,3,8,9,19,20,375);
my @degs = (2,3,7,14,310);
my @probs = (0.402370, 0.337770, 0.068134, 0.140780, 0.050937);
my $reps = 1000;
my $backtrack=0;
my $delta = 0.01;
my $good = 0.0;
my $one = 0; 
my $two = 0; 

while(1) {
  get_degree_string();
  print $degdist, "\n";
  my $blah=`../sparse/decoder-testing $size $seed $spares $degdist $reps`;
  print $blah;

  #parse $blah into "%i %f"
  $blah =~ /(\d+) (\d\.\d+)/;

  #change acceptance of new distribution to be probabilistic
  
  my $p = rand();
  print exp(1000*(f($1, $2)-$good)), " ", $p, "\n";
  if (exp(1000*(f($1, $2)-$good))>$p) {
    #print "Better\n";
    $good = f($1, $2);
    $backtrack = 0;
    print "New best: $good\n";
  }
  else {
    #restore where we were before
    #print "\n", $one, " ", $two, "\n";
    print "Backtracking\n";
    #decrement @degs[1] by $delta
    @probs[$one] -= $delta;
    #increment @degs[1] by $delta
    @probs[$two] += $delta;
    $backtrack++;
  }

  if($backtrack>=10) { #arbitrary
    #reduce delta
    $backtrack = 0;
    $delta = $delta*0.9;
    print "New delta: $delta\n";
  }
  
  #create new degree distribution based on result

  my $ret=1;
  while($ret) {
    #choose a random number between 0 and @degs-1
    $one = int(rand($#degs+1));

    #choose a second random number between 0 and @degs-2
    $two = int(rand($#degs));

    if ($one == $two) {
      $two = $#degs;
    }

    if(@probs[$one]>=$delta && @probs[$two]>=$delta) {
      #increment @degs[1] by $delta
      @probs[$one]+=$delta;
      #decrement @degs[1] by $delta
      @probs[$two] -= $delta;
      $ret=0;
    }
  }

}

sub get_degree_string {
  $degdist = "\"";
  foreach(0 .. @degs-1) {
    $degdist .= "(" . $degs[$_] . "," . $probs[$_] . ");";
  }
  $degdist .= "\"";
  return $degdist;
}

sub f {
  my $failures = shift;
  my $triangle = shift;
  
  #print $failures, " ", $triangle, "\n";
  if ($failures > 0){ return 0.0;}

  return $triangle;
  #return $triangle*100-$failures;

}

