/* Copyright 2006 Oliver Madge
 * 
 * This file is part of RU-decoder.
 *
 * RU-decoder is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2 as published
 * by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program in the file COPYING; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301  USA
 *
 */

#ifndef DEGREE_H
#define DEGREE_H

#include <stdio.h>
#include <stdint.h>
#include <math.h>
#include <stdlib.h>
#include <list>
#include "random.h"

using namespace std;

class degree {
  public:
    degree(int*, double*, int, Random *rand);

    ~degree();

    uint16_t getDegree();

    double alpha_star();

    list<int>* getPacketList(uint16_t deg, int list_size);

  private:
    long double rho(long double x);
    long double lambda(long double x);
    void cache_poisson();    

    long fact(int);

    Random *r;

    long double *cache;
    long double *pcache;
    long maxp;

    int K;

};

#endif

