/* Copyright 2006 Oliver Madge
 * 
 * This file is part of RU-decoder.
 *
 * RU-decoder is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2 as published
 * by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program in the file COPYING; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301  USA
 *
 */


#include <stdio.h>
#include <unistd.h>

#include "sparse.h"
#include "dense.h"
#include "columnvector.h"
#include <list>

using namespace std;


int main(int argc, char *argv[]){
  int c;
  while((c=getopt(argc, argv, "v"))!=-1) {  
    printf("Option %c\n", c);
    switch(c) {
      case 'v':
        printf("Verbose mode\n");
      default:
        ;
    }
  }

  denseMatrix *s5 = new denseMatrix(40,10);


  list<int> *l = new list<int>;

  l->push_back(0);
  l->push_back(4);
  l->push_back(6);
  l->push_back(9);
  l->push_back(31);
  l->push_back(32);

  s5->setRow(0, l);
  s5->setRow(2, l);
  s5->setRow(9, l);

  s5->prettyPrint();
  s5->debugPrint();

  return 0;
  
  printf("Sparse matrix library regression tests\n");
  printf("Need work\n");

  sparseMatrix *s = new sparseMatrix(10,10);
  sparseMatrix *s2 = new sparseMatrix(10,10);
  sparseMatrix *d = new sparseMatrix(10,10);

  s->insert(1,1);

  s->insert(8,3);
  s->insert(7,3);
  s->insert(5,3);
  s->insert(10,10);

  s2->insert(1,1);

  s2->insert(8,3);
  s2->insert(7,3);
  s2->insert(5,3);
  s2->insert(10,10);

  s->remove(10,10);
  s->remove(1,1);
  s->remove(7,3);

  printf("s\n");
  s->prettyPrint();
  printf("s2\n");
  s2->prettyPrint();
  printf("\n");

  s->add(s2);

  s->prettyPrint();
  
  return 0;

  d->prettyPrint();

  d->clear();
  s->add(s2, d);

  if(d->empty()) printf("d empty\n");
  else printf("d not empty\n");

  d->prettyPrint();

  printf("s\n");
  s->prettyPrint();
  printf("s2\n");
  s2->prettyPrint();

  printf("\n\n");
  s->multiply(s2, d);

  d->prettyPrint();
  printf("\n");
  d->prettyPrintTranspose();

  delete s;
  return 0;
}
